diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/static/js/schema.js b/web/pgadmin/browser/server_groups/servers/databases/schemas/static/js/schema.js
index 084e4cd9e..f606e384f 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/static/js/schema.js
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/static/js/schema.js
@@ -88,7 +88,9 @@ define('pgadmin.node.schema', [
 
         var gridHeader = _.template([
             '<div class="subnode-header">',
-            '  <span class="control-label col-sm-4"><%-label%></span>',
+            '<% if (label && label != "") %> {',
+            '    <span class="control-label col-sm-4"><%-label%></span>',
+            '}',
             '</div>'].join('\n')),
           gridBody = $('<div class="pgadmin-control-group backgrid form-group col-12 object subnode"></div>').append(
             gridHeader(attributes)
@@ -151,7 +153,8 @@ define('pgadmin.node.schema', [
   },{
     id: 'autovacuum_custom', label: gettext('Custom auto-vacuum?'),
     group: gettext('Table'), mode: ['edit', 'create'],
-    type: 'switch',
+    type: 'switch', controlLabelClassName: 'control-label pg-el-sm-4 pg-el-12',
+    controlsClassName: 'pgadmin-controls pg-el-sm-8 pg-el-12',
     disabled: function(m) {
       // If table is partitioned table then disabled it.
       if (m.top && m.top.get('is_partitioned')) {
@@ -169,45 +172,29 @@ define('pgadmin.node.schema', [
       return true;
     },
   },{
-    id: 'autovacuum_enabled', label: gettext('Enabled?'),
+    id: 'autovacuum_enabled', label: gettext('Autovacuum Enabled?'),
     group: gettext('Table'), mode: ['edit', 'create'],
-    type: 'switch',
+    type: 'radioModern', controlLabelClassName: 'control-label pg-el-sm-4 pg-el-12',
+    controlsClassName: 'pgadmin-controls pg-el-sm-8 pg-el-12',
+    options: [
+      {'label': gettext('Not set'), 'value': 'x'},
+      {'label': gettext('Yes'), 'value': 't'},
+      {'label': gettext('No'), 'value': 'f'},
+    ],
     deps: ['autovacuum_custom'],
     disabled: function(m) {
       if(!m.top.inSchema.apply(this, [m]) &&
         m.get('autovacuum_custom') == true) {
 
-        // If reloptions is null then set the autovacuum_enabled to true.
-        if (!_.isUndefined(m.get('reloptions')) &&
-          _.isNull(m.get('reloptions'))) {
-          setTimeout(function() {
-            m.set('autovacuum_enabled', true);
-          }, 10);
-        }
         return false;
       }
 
       // We also need to unset rest of all
       setTimeout(function() {
-        m.set('autovacuum_enabled', false);
+        m.set('autovacuum_enabled', 'x');
       }, 10);
       return true;
     },
-    control: Backform.SwitchControl.extend({
-      onChange: function() {
-        Backform.SwitchControl.prototype.onChange.apply(this, arguments);
-        let m = this.model;
-        // If value of autovacuum_enabled is false and reloptions is null
-        // then we should set the value of autovacuum_custom to false, as
-        // there is no query to run.
-        if (!m.get('autovacuum_enabled') && !_.isUndefined(m.get('reloptions'))
-          && _.isNull(m.get('reloptions'))) {
-          setTimeout(function() {
-            m.set('autovacuum_custom', false);
-          }, 10);
-        }
-      },
-    }),
   },{
     id: 'vacuum_table', label: '',
     model: Backform.VacuumTableModel, editable: false, type: 'collection',
@@ -224,7 +211,7 @@ define('pgadmin.node.schema', [
           name: 'value', label: gettext('Value'),
           cellHeaderClasses:'width_percent_30',
           cellFunction: Backform.cellFunction, editable: function(m) {
-            return m.handler.get('autovacuum_enabled');
+            return m.handler.get('autovacuum_custom');
           }, headerCell: Backgrid.Extension.CustomHeaderCell,
         },
         {
@@ -235,13 +222,14 @@ define('pgadmin.node.schema', [
         },
       ],
     }),
-    deps: ['autovacuum_enabled'],
+    deps: ['autovacuum_custom'],
   },{
     id: 'spacer_ctrl', group: gettext('TOAST table'), mode: ['edit', 'create'], type: 'spacer',
   },{
     id: 'toast_autovacuum', label: gettext('Custom auto-vacuum?'),
     group: gettext('TOAST table'), mode: ['edit', 'create'],
-    type: 'switch',
+    type: 'switch', controlLabelClassName: 'control-label pg-el-sm-4 pg-el-12',
+    controlsClassName: 'pgadmin-controls pg-el-sm-8 pg-el-12',
     disabled: function(m) {
       // We need to check additional condition to toggle enable/disable
       // for table auto-vacuum
@@ -255,50 +243,32 @@ define('pgadmin.node.schema', [
       return true;
     },
   },{
-    id: 'toast_autovacuum_enabled', label: gettext('Enabled?'),
+    id: 'toast_autovacuum_enabled', label: gettext('Autovacuum Enabled?'),
     group: gettext('TOAST table'), mode: ['edit', 'create'],
-    type: 'switch',
+    type: 'radioModern', controlLabelClassName: 'control-label pg-el-sm-4 pg-el-12',
+    controlsClassName: 'pgadmin-controls pg-el-sm-8 pg-el-12',
+    options: [
+      {'label': gettext('Not set'), 'value': 'x'},
+      {'label': gettext('Yes'), 'value': 't'},
+      {'label': gettext('No'), 'value': 'f'},
+    ],
     deps:['toast_autovacuum'],
     disabled: function(m) {
       // If in schema & in create mode then enable it
       if(!m.top.inSchema.apply(this, [m]) &&
           m.get('toast_autovacuum') === true) {
 
-        // If reloptions is null then set the autovacuum_enabled to true.
-        if (!_.isUndefined(m.get('toast_reloptions')) &&
-          _.isNull(m.get('toast_reloptions'))) {
-          setTimeout(function() {
-            m.set('toast_autovacuum_enabled', true);
-          }, 10);
-        }
-
         return false;
       }
 
       if (m.isNew() || m.get('hastoasttable')) {
         // we also need to unset rest of all
         setTimeout(function() {
-          m.set('toast_autovacuum_enabled', false);
+          m.set('toast_autovacuum_enabled', 'x');
         }, 10);
       }
       return true;
     },
-    control: Backform.SwitchControl.extend({
-      onChange: function() {
-        Backform.SwitchControl.prototype.onChange.apply(this, arguments);
-
-        let m = this.model;
-        // If value of autovacuum_enabled is false and reloptions is null
-        // then we should set the value of autovacuum_custom to false, as
-        // there is no query to run.
-        if (!m.get('toast_autovacuum_enabled') && !_.isUndefined(m.get('toast_reloptions'))
-          && _.isNull(m.get('toast_reloptions'))) {
-          setTimeout(function() {
-            m.set('toast_autovacuum', false);
-          }, 10);
-        }
-      },
-    }),
   },{
     id: 'vacuum_toast', label: '',
     model: Backform.VacuumTableModel, type: 'collection', editable: function(m) {
@@ -318,7 +288,7 @@ define('pgadmin.node.schema', [
           cellHeaderClasses:'width_percent_30',
           headerCell: Backgrid.Extension.CustomHeaderCell,
           cellFunction: Backform.cellFunction, editable: function(m) {
-            return m.handler.get('toast_autovacuum_enabled');
+            return m.handler.get('toast_autovacuum');
           },
         },
         {
@@ -329,7 +299,7 @@ define('pgadmin.node.schema', [
         },
       ],
     }),
-    deps: ['toast_autovacuum_enabled'],
+    deps: ['toast_autovacuum'],
   }];
 
   // Extend the browser's collection class for schema collection
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/__init__.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/__init__.py
index 03073e277..68b945c56 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/__init__.py
@@ -619,6 +619,42 @@ class TableView(BaseTableView, DataTypeReader, VacuumSettings,
             return False, gone(
                 gettext("The specified table could not be found."))
 
+        # Set value based on
+        # x: No set, t: true, f: false
+        res['rows'][0]['autovacuum_enabled'] = 'x' \
+            if res['rows'][0]['autovacuum_enabled'] is None else \
+            {True: 't', False: 'f'}[res['rows'][0]['autovacuum_enabled']]
+
+        res['rows'][0]['toast_autovacuum_enabled'] = 'x' \
+            if res['rows'][0]['toast_autovacuum_enabled'] is None else \
+            {True: 't', False: 'f'}[res['rows'][0]['toast_autovacuum_enabled']]
+
+        # Enable custom autovaccum only if one of the options is set
+        # or autovacuum is set
+        res['rows'][0]['autovacuum_custom'] = any([
+            res['rows'][0]['autovacuum_vacuum_threshold'],
+            res['rows'][0]['autovacuum_vacuum_scale_factor'],
+            res['rows'][0]['autovacuum_analyze_threshold'],
+            res['rows'][0]['autovacuum_analyze_scale_factor'],
+            res['rows'][0]['autovacuum_vacuum_cost_delay'],
+            res['rows'][0]['autovacuum_vacuum_cost_limit'],
+            res['rows'][0]['autovacuum_freeze_min_age'],
+            res['rows'][0]['autovacuum_freeze_max_age'],
+            res['rows'][0]['autovacuum_freeze_table_age']]) \
+            or res['rows'][0]['autovacuum_enabled'] in ('t', 'f')
+
+        res['rows'][0]['toast_autovacuum'] = any([
+            res['rows'][0]['toast_autovacuum_vacuum_threshold'],
+            res['rows'][0]['toast_autovacuum_vacuum_scale_factor'],
+            res['rows'][0]['toast_autovacuum_analyze_threshold'],
+            res['rows'][0]['toast_autovacuum_analyze_scale_factor'],
+            res['rows'][0]['toast_autovacuum_vacuum_cost_delay'],
+            res['rows'][0]['toast_autovacuum_vacuum_cost_limit'],
+            res['rows'][0]['toast_autovacuum_freeze_min_age'],
+            res['rows'][0]['toast_autovacuum_freeze_max_age'],
+            res['rows'][0]['toast_autovacuum_freeze_table_age']]) \
+            or res['rows'][0]['toast_autovacuum_enabled'] in ('t', 'f')
+
         # We will check the threshold set by user before executing
         # the query because that can cause performance issues
         # with large result set
@@ -943,6 +979,11 @@ class TableView(BaseTableView, DataTypeReader, VacuumSettings,
                 data['partition_scheme'] = self.get_partition_scheme(data)
                 partitions_sql = self.get_partitions_sql(data)
 
+            # Update the vacuum table settings.
+            BaseTableView.update_vacuum_settings(self, 'vacuum_table', data)
+            # Update the vacuum toast table settings.
+            BaseTableView.update_vacuum_settings(self, 'vacuum_toast', data)
+
             SQL = render_template(
                 "/".join([self.table_template_path, 'create.sql']),
                 data=data, conn=self.conn
@@ -1023,14 +1064,9 @@ class TableView(BaseTableView, DataTypeReader, VacuumSettings,
                 data[k] = v
 
         try:
-            SQL = render_template(
-                "/".join([self.table_template_path, 'properties.sql']),
-                did=did, scid=scid, tid=tid,
-                datlastsysoid=self.datlastsysoid
-            )
-            status, res = self.conn.execute_dict(SQL)
+            status, res = self._fetch_properties(did, scid, tid)
             if not status:
-                return internal_server_error(errormsg=res)
+                return res
 
             return super(TableView, self).update(
                 gid, sid, did, scid, tid, data, res)
@@ -1266,14 +1302,9 @@ class TableView(BaseTableView, DataTypeReader, VacuumSettings,
         res = None
 
         if tid is not None:
-            SQL = render_template(
-                "/".join([self.table_template_path, 'properties.sql']),
-                did=did, scid=scid, tid=tid,
-                datlastsysoid=self.datlastsysoid
-            )
-            status, res = self.conn.execute_dict(SQL)
+            status, res = self._fetch_properties(did, scid, tid)
             if not status:
-                return internal_server_error(errormsg=SQL)
+                return res
 
         SQL, name = self.get_sql(did, scid, tid, data, res)
         SQL = re.sub('\n{2,}', '\n\n', SQL)
@@ -1335,17 +1366,9 @@ class TableView(BaseTableView, DataTypeReader, VacuumSettings,
         """
         main_sql = []
 
-        SQL = render_template(
-            "/".join([self.table_template_path, 'properties.sql']),
-            did=did, scid=scid, tid=tid,
-            datlastsysoid=self.datlastsysoid
-        )
-        status, res = self.conn.execute_dict(SQL)
+        status, res = self._fetch_properties(did, scid, tid)
         if not status:
-            return internal_server_error(errormsg=res)
-
-        if len(res['rows']) == 0:
-            return gone(gettext("The specified table could not be found."))
+            return res
 
         data = res['rows'][0]
 
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/partitions/static/js/partition.js b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/partitions/static/js/partition.js
index 9ce744cfa..68b2209a8 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/partitions/static/js/partition.js
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/partitions/static/js/partition.js
@@ -330,8 +330,8 @@ function(
           is_sys_table: undefined,
           coll_inherits: [],
           hastoasttable: true,
-          toast_autovacuum_enabled: false,
-          autovacuum_enabled: false,
+          toast_autovacuum_enabled: 'x',
+          autovacuum_enabled: 'x',
           primary_key: [],
           partitions: [],
           partition_type: 'range',
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/static/js/table.js b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/static/js/table.js
index d65957132..0e73de872 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/static/js/table.js
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/static/js/table.js
@@ -300,8 +300,8 @@ define('pgadmin.node.table', [
           is_sys_table: undefined,
           coll_inherits: [],
           hastoasttable: true,
-          toast_autovacuum_enabled: false,
-          autovacuum_enabled: false,
+          toast_autovacuum_enabled: 'x',
+          autovacuum_enabled: 'x',
           primary_key: [],
           partitions: [],
           partition_type: 'range',
@@ -1149,6 +1149,16 @@ define('pgadmin.node.table', [
           id: 'vacuum_settings_str', label: gettext('Storage settings'),
           type: 'multiline', group: 'advanced', mode: ['properties'],
         }],
+        sessChanged: function() {
+          /* If only custom autovacuum option is enabled the check if the options table is also changed. */
+          if(_.size(this.sessAttrs) == 2 && this.sessAttrs['autovacuum_custom'] && this.sessAttrs['toast_autovacuum']) {
+            return this.get('vacuum_table').sessChanged() || this.get('vacuum_toast').sessChanged();
+          }
+          if(_.size(this.sessAttrs) == 1 && (this.sessAttrs['autovacuum_custom'] || this.sessAttrs['toast_autovacuum'])) {
+            return this.get('vacuum_table').sessChanged() || this.get('vacuum_toast').sessChanged();
+          }
+          return pgBrowser.DataModel.prototype.sessChanged.apply(this);
+        },
         validate: function() {
           var msg,
             name = this.get('name'),
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/tests/test_table_parameters.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/tests/test_table_parameters.py
index bbed26998..4bd59f5c1 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/tests/test_table_parameters.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/tests/test_table_parameters.py
@@ -25,25 +25,104 @@ class TableUpdateParameterTestCase(BaseTestGenerator):
     """This class will add new collation under schema node."""
     scenarios = [
         # Fetching default URL for table node.
-        ('Enable custom auto vacuum and set the parameters for table',
-         dict(url='/browser/table/obj/', type='set_vacuum_parameters')
+        ('Enable custom auto vacuum and set the parameters for table '
+         'without autovacuum_enabled',
+         dict(url='/browser/table/obj/',
+              api_data={
+                  'autovacuum_custom': True,
+                  'vacuum_table': {
+                      'changed': [
+                          {'name': 'autovacuum_vacuum_cost_delay',
+                           'value': 20},
+                          {'name': 'autovacuum_vacuum_threshold',
+                           'value': 20}
+                      ]
+                  }}
+              )
          ),
-        ('Disable auto vacuum and reset the parameters for table',
-         dict(url='/browser/table/obj/', type='reset_vacuum_parameters')
+        ('Change a parameter to zero value '
+         'without autovacuum_enabled',
+         dict(url='/browser/table/obj/',
+              api_data={
+                  'vacuum_table': {
+                      'changed': [
+                          {'name': 'autovacuum_vacuum_cost_delay',
+                           'value': 0}
+                      ]
+                  }}
+              )
          ),
-        ('Disable custom auto vacuum and reset all the parameters for table',
-         dict(url='/browser/table/obj/', type='reset_all_vacuum_parameters')
+        ('Enable autovacuum_enabled',
+         dict(url='/browser/table/obj/',
+              api_data={'autovacuum_enabled': 't'}
+              )
          ),
-        ('Enable custom auto vacuum and set the toast parameters for table',
-         dict(url='/browser/table/obj/', type='set_toast_parameters')
+        ('Reset individual parameters for table',
+         dict(url='/browser/table/obj/',
+              api_data={
+                  'autovacuum_enabled': 'x',
+                  'vacuum_table': {
+                      'changed': [
+                          {'name': 'autovacuum_vacuum_cost_delay',
+                           'value': None},
+                      ]
+                  }}
+              )
          ),
-        ('Disable auto vacuum and reset the toast parameters for table',
-         dict(url='/browser/table/obj/', type='reset_toast_parameters')
+        ('Reset custom auto vacuum',
+         dict(url='/browser/table/obj/',
+              api_data={'autovacuum_custom': False}
+              )
+         ),
+        ('Enable toast custom auto vacuum and set the parameters for table '
+         'without autovacuum_enabled',
+         dict(url='/browser/table/obj/',
+              api_data={
+                  'toast_autovacuum': True,
+                  'vacuum_toast': {
+                      'changed': [
+                          {'name': 'autovacuum_vacuum_cost_delay',
+                           'value': 20},
+                          {'name': 'autovacuum_vacuum_threshold',
+                           'value': 20}
+                      ]
+                  }}
+              )
+         ),
+        ('Change a toast parameter to zero value '
+         'without autovacuum_enabled',
+         dict(url='/browser/table/obj/',
+              api_data={
+                  'vacuum_toast': {
+                      'changed': [
+                          {'name': 'autovacuum_vacuum_cost_delay',
+                           'value': 0}
+                      ]
+                  }}
+              )
+         ),
+        ('Enable toast.autovacuum_enabled',
+         dict(url='/browser/table/obj/',
+              api_data={'toast_autovacuum_enabled': 't'}
+              )
+         ),
+        ('Reset individual toast parameters for table',
+         dict(url='/browser/table/obj/',
+              api_data={
+                  'toast_autovacuum_enabled': 'x',
+                  'vacuum_toast': {
+                      'changed': [
+                          {'name': 'autovacuum_vacuum_cost_delay',
+                           'value': None},
+                      ]
+                  }}
+              )
+         ),
+        ('Reset auto vacuum',
+         dict(url='/browser/table/obj/',
+              api_data={'toast_autovacuum': False}
+              )
          ),
-        ('Disable custom auto vacuum and reset all the toast '
-         'parameters for table',
-         dict(url='/browser/table/obj/', type='reset_all_toast_parameters')
-         )
     ]
 
     @classmethod
@@ -77,50 +156,8 @@ class TableUpdateParameterTestCase(BaseTestGenerator):
         if not table_response:
             raise Exception("Could not find the table to update.")
 
-        data = None
-        if self.type == 'set_vacuum_parameters':
-            data = dict({'oid': self.table_id,
-                         'autovacuum_custom': True,
-                         'autovacuum_enabled': True,
-                         'vacuum_table': dict({'changed': [
-                             {'name': 'autovacuum_vacuum_cost_delay',
-                              'value': 20},
-                             {'name': 'autovacuum_vacuum_threshold',
-                              'value': 20}
-                         ]})})
-        elif self.type == 'reset_vacuum_parameters':
-            data = dict({'oid': self.table_id,
-                         'autovacuum_enabled': False,
-                         'vacuum_table': dict({'changed': [
-                             {'name': 'autovacuum_vacuum_cost_delay',
-                              'value': None},
-                             {'name': 'autovacuum_vacuum_threshold',
-                              'value': None}
-                         ]})})
-        elif self.type == 'reset_all_vacuum_parameters':
-            data = dict({'oid': self.table_id, 'autovacuum_custom': False})
-        elif self.type == 'set_toast_parameters':
-            data = dict({'oid': self.table_id,
-                         'autovacuum_custom': True,
-                         'autovacuum_enabled': True,
-                         'vacuum_toast': dict({'changed': [
-                             {'name': 'autovacuum_vacuum_cost_delay',
-                              'value': 20},
-                             {'name': 'autovacuum_vacuum_threshold',
-                              'value': 20}
-                         ]})})
-        elif self.type == 'reset_toast_parameters':
-            data = dict({'oid': self.table_id,
-                         'autovacuum_enabled': False,
-                         'vacuum_toast': dict({'changed': [
-                             {'name': 'autovacuum_vacuum_cost_delay',
-                              'value': None},
-                             {'name': 'autovacuum_vacuum_threshold',
-                              'value': None}
-                         ]})})
-        elif self.type == 'reset_all_toast_parameters':
-            data = dict({'oid': self.table_id, 'autovacuum_custom': False})
-
+        data = self.api_data
+        data['oid'] = self.table_id
         response = self.tester.put(self.url + str(utils.SERVER_GROUP) + '/' +
                                    str(self.server_id) + '/' +
                                    str(self.db_id) + '/' +
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/utils.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/utils.py
index c552006ab..6a442bfd6 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/utils.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/utils.py
@@ -1029,6 +1029,11 @@ class BaseTableView(PGChildNodeView, BasePartitionTable):
                 data['partition_scheme'] = self.get_partition_scheme(data)
                 partitions_sql = self.get_partitions_sql(data)
 
+            # Update the vacuum table settings.
+            self.update_vacuum_settings('vacuum_table', data)
+            # Update the vacuum toast table settings.
+            self.update_vacuum_settings('vacuum_toast', data)
+
             SQL = render_template("/".join([self.table_template_path,
                                             'create.sql']),
                                   data=data, conn=self.conn)
@@ -1191,21 +1196,20 @@ class BaseTableView(PGChildNodeView, BasePartitionTable):
         """
         data = res['rows'][0]
 
-        data['vacuum_settings_str'] = ""
+        data['vacuum_settings_str'] = ''
 
-        if data['table_vacuum_settings_str'] is not None:
-            data['vacuum_settings_str'] += data[
-                'table_vacuum_settings_str'].replace(',', '\n')
+        if data['reloptions'] is not None:
+            data['vacuum_settings_str'] += '\n'.join(data['reloptions'])
+
+        if data['toast_reloptions'] is not None:
+            data['vacuum_settings_str'] += '\n' \
+                if data['vacuum_settings_str'] != '' else ''
+            data['vacuum_settings_str'] += '\n'.\
+                join(map(lambda o: 'toast.' + o, data['toast_reloptions']))
 
-        if data['toast_table_vacuum_settings_str'] is not None:
-            data['vacuum_settings_str'] += '\n' + '\n'.join(
-                ['toast_' + setting for setting in data[
-                    'toast_table_vacuum_settings_str'
-                ].split(',')]
-            )
         data['vacuum_settings_str'] = data[
             'vacuum_settings_str'
-        ].replace("=", " = ")
+        ].replace('=', ' = ')
 
         data = self._formatter(did, scid, tid, data)
 
@@ -1496,7 +1500,7 @@ class BaseTableView(PGChildNodeView, BasePartitionTable):
 
         return schema_name, table_name
 
-    def update_vacuum_settings(self, vacuum_key, old_data, data):
+    def update_vacuum_settings(self, vacuum_key, old_data, data=None):
         """
         This function iterate the vacuum and vacuum toast table and create
         two new dictionaries. One for set parameter and another for reset.
@@ -1507,8 +1511,14 @@ class BaseTableView(PGChildNodeView, BasePartitionTable):
         :return:
         """
 
+        # When creating a table old_data is the actual data
+        if data is None:
+            if vacuum_key in old_data:
+                for opt in old_data[vacuum_key]:
+                    if 'value' in opt and opt['value'] is None:
+                        opt.pop('value')
         # Iterate vacuum table
-        if vacuum_key in data and 'changed' in data[vacuum_key] \
+        elif vacuum_key in data and 'changed' in data[vacuum_key] \
                 and vacuum_key in old_data:
             set_values = []
             reset_values = []
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/utils.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/utils.py
index be3c43c52..f7b8e701b 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/utils.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/utils.py
@@ -10,6 +10,7 @@
 """Schema collection node helper class"""
 
 import json
+import copy
 
 from flask import render_template
 
@@ -575,8 +576,8 @@ class VacuumSettings:
         * type - table/toast vacuum type
         """
 
-        vacuum_settings_tmp = self.fetch_default_vacuum_settings(
-            conn, self.manager.sid, type)
+        vacuum_settings_tmp = copy.deepcopy(self.fetch_default_vacuum_settings(
+            conn, self.manager.sid, type))
 
         for row in vacuum_settings_tmp:
             row_name = row['name']
@@ -585,6 +586,7 @@ class VacuumSettings:
             if row_name in result and result[row_name] is not None:
                 if row['column_type'] == 'number':
                     value = float(result[row_name])
+                    value = int(value) if value % 1 == 0 else value
                 else:
                     value = int(result[row_name])
                 row['value'] = value
